library MyWeather;

{*****************************************************************************
 *                                        *
 * () Andrew ++, 2008                                                       *
 *                       *
 *     GNU GPL v2                                     *
 *     Overbyte Ics (http://www.overbyte.be)   *
 *****************************************************************************}

uses
  types,
  windows,
  SysUtils,
  Classes,
  Graphics,
  mmSystem,
  IniFiles,
  typinfo,
  ShellAPI,
  CallExec in 'CallExec.pas',
  plugin in 'plugin.pas',
  pluginutil in 'pluginutil.pas',
  RqUtils in 'RqUtils.pas',
  WeatherUtils in 'MyWeather\WeatherUtils.pas',
  WeatherForm in 'WeatherForm\WeatherForm.pas' {WeatherFrm};

type
  syncThread = class(TThread)
  private
    { Private declarations }
    procedure Sync;
  protected
    procedure Execute; override;
  end;

const
 namepl: string = 'MyWeather 0.3.2';

 //UINpl: integer = 900000001;
 IniFileName: string = 'MyWeather.ini';

var
 path, userPath: string;
 curUIN:integer;
 uin, flags, APIver:integer;
 //dt:TDateTime;
 msg: string;
 {--------------------------}
 Weather: TWeather;
 ParserFile: string;
 Proxy: TProxySettings;
 Ba: integer;
 Icon: TIcon;
 {--------------------------}
 MyUpdateTimer: Cardinal;        //     TTimer
 MyUpdateTimerEnabled: boolean = false;
 UpdateInterval: integer;
 UpdateType: integer;
 {--------------------------}
 ImgPath: string;
 FrmTitle: string;
 {--------------------------}
 RetryCount: integer;
 RetryInterval: integer;

// ############################################################################

procedure syncThread.Sync;
begin
//
end;
//-----------------------------------------------------------------------------
procedure syncThread.Execute;
begin
  { Place thread code here }
  FreeOnTerminate := true;

  try
    Weather.GetWeatherForTownList(RetryCount, RetryInterval);
    if Length(Weather.Weather.Text) = 0 then
      Weather.Weather.Text := '   ';
  except
    on E:Exception do Weather.Weather.Text := E.Message;
  end;
  
  Terminate;
end;

(*procedure syncThread.Execute;
var
  WeatherData: TStringList;
begin
  { Place thread code here }
  FreeOnTerminate := true;

  WeatherData := TStringList.Create;
  WeatherData.Clear;

  WeatherData.LoadFromFile('C:\My Projects\DELPHI\RnQPlugins\MyWeather\MyWeatherPlugin\MyWeather\27402.txt');
  Weather.ParseWeather(WeatherData.Text);

  WeatherData.Clear;
  WeatherData.Add(Weather.Weather.Text);

  WeatherData.Free;
  WeatherData := nil;

  Synchronize(Sync);

  Terminate;
end;*)

// ############################################################################

procedure ExecuteFile(const aFileName, aParams: String);
var
  FileName, Param: String;
  fn, par: PAnsiChar;
begin
  FileName := aFileName;
  Param := aParams;
  fn := StrNew(PChar(FileName));
  try
    par := StrNew(PChar(Param));
    try
      ShellExecute(0{Handle}, 'open', fn, par, '', SW_RESTORE)
    finally
      StrDispose(par);
    end;
  finally
    StrDispose(fn);
  end;
end;

// ############################################################################

procedure ReadIni;
var
  IniFile: TIniFile;
begin
  if not FileExists(userPath + IniFileName) then
    raise Exception.Create('   ');

  IniFile         := TIniFile.Create(userPath + IniFileName);

  //  -
  Proxy.ProxyType := TProxyType(GetEnumValue(typeinfo(TProxyType),
    IniFile.ReadString('Proxy', 'Type', 'PT_NONE')));
  Proxy.Address   := IniFile.ReadString('Proxy', 'Addr', '127.0.0.1');
  Proxy.Port      := IniFile.ReadString('Proxy', 'Port', '3128');
  Proxy.NeedAuth  := false;

  //GetEnumValue(typeinfo(TProxyType), 'PT_HTTP');
  //getEnumName(typeinfo(TProxyType),ord(PT_HTTP));

  ParserFile      := path + 'plugins\MyWeather\' +
    IniFile.ReadString('Settings', 'ParserFile', 'parser.gismeteo.ini');

  Icon            := TIcon.Create;
  Icon.LoadFromFile(path + 'plugins\MyWeather\' +
    IniFile.ReadString('Settings', 'Icon', 'weather.ico'));

  ImgPath         := path + 'plugins\MyWeather\' +
    IniFile.ReadString('Settings', 'Image', 'weather.bmp');

  FrmTitle        := IniFile.ReadString('Settings', 'FrmTitle', '');

  //  
  Weather               := TWeather.Create(ParserFile);
  Weather.ProxySettings := Proxy;

  UpdateInterval  := 60000 * IniFile.ReadInteger('Settings', 'UpdateInterval', 60);
  UpdateType      := IniFile.ReadInteger('Settings', 'UpdateType', 1);

  RetryCount      := IniFile.ReadInteger('Settings', 'RetryCount', 0);
  RetryInterval   := IniFile.ReadInteger('Settings', 'RetryInterval', 0);

  IniFile.ReadSection('Towns', Weather.TownList);

  IniFile.Free;
end;
//-----------------------------------------------------------------------------
procedure UpdateWeather;
var
  syncThr: syncThread;
begin
  syncThr := syncThread.Create(false);

  //Weather.GetWeatherForTownList;
  //RQ_AddMessage(UINpl, Weather.Weather.Text);
end;
//-----------------------------------------------------------------------------
procedure OnButtonClick(AButton: Integer);
var
  data:pointer;
begin
  case AButton of
    0: { }
      begin
        data := callStr(char(PM_GET) + char(PG_WINDOW) + char(PW_CHAT));

        WeatherFrm := TWeatherFrm.Create(_int_at(data, 5), Weather,
          ImgPath, namepl, FrmTitle);
        WeatherFrm.RefreshWeather;
        WeatherFrm.ShowModal;
        WeatherFrm.Free;
      end;
      //RQ_AddMessage(RQ_GetChatUIN, Weather.Weather.Text);
      //RQ_AddToInput(Weather.Weather.Text);
    1: { }
      UpdateWeather;
    2: { };
  end;
end;
//-----------------------------------------------------------------------------
procedure FNUpdateTimeCallBack(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD); stdcall;
begin
  if uTimerID = MyUpdateTimer then
  begin
    UpdateWeather;
  end;
end;
//-----------------------------------------------------------------------------
procedure StartUpdateTimer;
begin
  if UpdateInterval > 0 then
  begin
    MyUpdateTimer := TimeSetEvent(UpdateInterval{}, 10000{},
      @FNUpdateTimeCallBack, 100, TIME_PERIODIC);
    MyUpdateTimerEnabled := true;
  end;
end;
//-----------------------------------------------------------------------------
procedure StopUpdateTimer;
begin
  if MyUpdateTimerEnabled then timeKillEvent(MyUpdateTimer);
  MyUpdateTimerEnabled := false;
end;

// ############################################################################

function pluginFun(data:pointer):pointer; stdcall;
begin
  result:=NIL;
  if (data=NIL) or (_int_at(data)=0) then exit;
  case _byte_at(data,4) of
    PM_EVENT:
      case _byte_at(data,5) of
        PE_INITIALIZE:
          begin
            // Parsing incoming string
            RQ__ParseInitString(data, callback, APIver, path, userPath, curUIN);

            if RQ_GetRnQVersion < 1074 then
            begin
              MessageBox(0, PChar(Format(',  %s       RnQ.'+
                #13',     ', [namepl])),
                PChar(namepl), MB_ICONHAND);
              Exit;
            end;

            {-----------------------------------------------------------------}
            ReadIni;

            if UpdateType = 1 then
            begin
              UpdateWeather;
              StartUpdateTimer;
            end;
            {-----------------------------------------------------------------}

            Ba := RQ_CreateChatButton(@OnButtonClick, Icon, namepl + ' (  -  ,  - )');

            // Reply with plugin name
            result:=str2comm(char(PM_DATA)+_istring(namepl)+_int(APIversion));
          end;

        PE_FINALIZE:
          begin
            // Free your object here ;-)
            if Weather <> nil then
            begin
              Weather.Free;
              Weather := nil;
            end;

            if Icon <> nil then
            begin
              Icon.Free;
              Icon := nil;
            end;

            if UpdateType = 1 then
              StopUpdateTimer;

            RQ_DeleteChatButton(Ba);
          end;

        PE_PREFERENCES:
          begin
            // Show Preference Windows here
            ExecuteFile(userPath + IniFileName, '');
          end;

        {=====================================================================}

        PE_CONNECTED:
          begin
            if UpdateType <> 1 then
            begin
              UpdateWeather;
              StartUpdateTimer;
            end;
          end;

        PE_DISCONNECTED:
          begin
            if UpdateType <> 1 then
              StopUpdateTimer;
          end;

        {=====================================================================}

        (*PE_MSG_SENT:
          begin
            // Parsing incoming string
            RQ__ParseMsgSentString(data, uin, flags, msg);

            //      UIN  
            if uin = UINpl then result := str2comm(char(PM_ABORT));
          end;*)
      end;//case
  end;//case
end; // pluginFun

exports
  pluginFun;



end.
