unit WeatherForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, XPMan, ComCtrls, ToolWin, ImgList, WeatherUtils;

type
  TWeatherFrm = class(TForm)
    WeatherGrid: TStringGrid;
    XPManifest1: TXPManifest;
    iml: TImageList;
    procedure WeatherGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Weather: TWeather;
    Town: string;

    constructor Create(aOwnerHWND: HWND; aWeather: TWeather;
      const aImgPath, aCaption, aTown: string);reintroduce;
    procedure RefreshWeather;
  end;

var
  WeatherFrm: TWeatherFrm;
  ColImg: TBitmap;

implementation

{$R *.dfm}

procedure TWeatherFrm.WeatherGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  Shift: integer;
begin
  WeatherGrid.Canvas.Font.Color := clBlack;
  WeatherGrid.Canvas.Font.Style := [fsBold];
  WeatherGrid.Canvas.Font.Size := 8;

  if ARow mod 2 = 1 then
  begin
    WeatherGrid.Canvas.Brush.Color := TColor($F0F0F0);//clGray;
  end else begin
    WeatherGrid.Canvas.Brush.Color := clWhite;//clGray;
  end;

  // 
  WeatherGrid.canvas.fillRect(Rect);

  if (ACol = 0) and (ARow = 0) then
  begin
    WeatherGrid.RowHeights[0] := ColImg.Height + 10;
    WeatherGrid.Canvas.Draw(Rect.Left + 5,
      round((Rect.Top + Rect.Bottom - ColImg.Height)/2), ColImg);
    Shift := ColImg.Width + 5;
  end else Shift := 0;

  if (ACol = 1) and (ARow = 0) then
  begin
    WeatherGrid.Canvas.Font.Size := 14;
  end;

  //  (Text).       ....
  WeatherGrid.canvas.TextOut(Rect.Left + Shift + 5,
    round((Rect.Top + Rect.Bottom - WeatherGrid.canvas.TextHeight(WeatherGrid.Cells[ACol,ARow]))/2),
    WeatherGrid.Cells[ACol,ARow]);

  //Shift := WeatherGrid.canvas.TextHeight(WeatherGrid.Cells[ACol,ARow]);
  //if Shift > WeatherGrid.ColWidths[ACol] then
  //begin
  //  WeatherGrid.ColWidths[ACol] := Shift;
  //end;
end;
//-----------------------------------------------------------------------------
constructor TWeatherFrm.Create(aOwnerHWND: HWND; aWeather: TWeather;
  const aImgPath, aCaption, aTown: string);
begin
  Application.Handle := aOwnerHWND;
  inherited Create(Application);
  ColImg := TBitmap.Create;
  ColImg.LoadFromFile(aImgPath);

  Caption := aCaption;

  WeatherGrid.ColWidths[0] := 160;
  WeatherGrid.ColWidths[1] := 150;
  Width := WeatherGrid.ColWidths[0] + WeatherGrid.ColWidths[1] + 10;

  if Length(aTown) > 0 then Town := aTown else Town := DateToStr(now);

  Weather := aWeather;
  Weather.Weather.NameValueSeparator := ':';
end;
//-----------------------------------------------------------------------------
procedure TWeatherFrm.RefreshWeather;
var
  i: integer;
begin
  WeatherGrid.RowCount := Weather.Weather.Count + 1;
  WeatherGrid.Cells[1, 0] := Town;
  for i := 0 to Weather.Weather.Count - 1 do
  begin
    WeatherGrid.Cells[0, i+1] := Weather.Weather.Names[i];
    WeatherGrid.Cells[1, i+1] := Weather.Weather.ValueFromIndex[i];
  end;
end;
//-----------------------------------------------------------------------------
procedure TWeatherFrm.FormDestroy(Sender: TObject);
begin
  ColImg.Free;
end;




end.
